program TestSmart;

uses Windows, Smart, SmartHelper, NLib;

var
  i, drv: Integer;
begin
  try
    if Argc < 2 then
      drv := 0
    else
      drv := SInt(Argv[1]);
    with TSmart.Create(drv) do
      try
        //DeviceIoControl(sm.Handle, DFP_GET_VERSION, nil, 0, @VersionPArams, SizeOf(VersionParams), retsize, nil);
        //Write('IDEDeviceMap:', VersionParams.bIDEDeviceMap);
        //Writeln(' Capabilities:', VersionParams.fCapabilities);
  
        if ReadIdSector then
          Writeln('Model number: ', Id.sModelNumber)
        else
          Writeln('cannot read id sector');
  
        if ReadAttrValues then
        begin
          Writeln('ID'#9'Value'#9'Worst'#9'Raw data');
          for i := 0 to NUM_ATTRIBUTE_STRUCTS-1 do
            Writeln(Attr[i].bAttrID, #9,
                    Attr[i].bAttrValue, #9,
                    Attr[i].bWorstValue, #9,
                    Attr[i].bRawValue[0], ' ',
                    Attr[i].bRawValue[1], ' ',
                    Attr[i].bRawValue[2], ' ',
                    Attr[i].bRawValue[3], ' ',
                    Attr[i].bRawValue[4], ' ',
                    Attr[i].bRawValue[5]);
        end
        else begin
          Writeln('cannot read attribute values');
          Exit;
        end;
      finally
        Free;
      end;
    except
      on E: EIOError do
        Writeln(E.Path + ': ' + E.Msg);
    end;
end.
